unit Common;

interface

uses
  System.SysUtils, System.Classes, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool, FireDAC.Stan.Async,
  FireDAC.Phys, FireDAC.Phys.FB, FireDAC.Phys.FBDef, FireDAC.VCLUI.Wait, Data.DB, FireDAC.Comp.Client, FireDAC.Phys.MSSQL, FireDAC.Phys.MSSQLDef, dbcDBEngine, dbcConnection_FireDAC,
  dbcTableDataComparer, dbcClasses, dbcSQL_Exec, dbcMSSQLExec, FireDAC.Comp.UI, FireDAC.DApt;

type
  TdmCommon = class(TDataModule)
    fdcBDE: TFDConnection;
    fdcDaimler: TFDConnection;
    tdc: TTableDataComparer;
    dbccConnectionBDE: TDBCConnectionFireDAC;
    dbccConnectionDaimler: TDBCConnectionFireDAC;
    SQLExec: TMSSQLExec;
    FDGUIxWaitCursor1: TFDGUIxWaitCursor;
    procedure tdcGetSelectSQL(Sender: TObject; const SQLM, SQLT: TStrings);
    procedure tdcGetKeyFields(Sender: TObject; const FieldsM, FieldsT: TStrings);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    Function SyncData:Boolean;
  end;

var
  dmCommon: TdmCommon;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TdmCommon }

function TdmCommon.SyncData: Boolean;
begin
  Result:= False;

  tdc.TableNameMaster := 'ALARME';
  tdc.TableOptionsMaster.DataFields.Clear;
  tdc.TableOptionsMaster.KeyFields.Clear;

  tdc.TableOptionsMaster.DataFields.Add('SPS_NODE');
  tdc.TableOptionsMaster.DataFields.Add('ELEMENT');
  tdc.TableOptionsMaster.DataFields.Add('KOMMT');
  tdc.TableOptionsMaster.DataFields.Add('GEHT');

  tdc.TableOptionsMaster.KeyFields.Add('SPS_NODE');
  tdc.TableOptionsMaster.KeyFields.Add('ELEMENT');

  tdc.TableNameTarget := 'Alarme';
  tdc.TableOptionsTarget.DataFields.Clear;
  tdc.TableOptionsTarget.KeyFields.Clear;

  tdc.TableOptionsTarget.DataFields.Add('PLC_ID');
  tdc.TableOptionsTarget.DataFields.Add('Alarm_no');
  tdc.TableOptionsTarget.DataFields.Add('Alarm_On');
  tdc.TableOptionsTarget.DataFields.Add('Alarm_Off');

  tdc.TableOptionsTarget.KeyFields.Add('PLC_ID');
  tdc.TableOptionsTarget.KeyFields.Add('Alarm_no');

  tdc.CompareData();

  Result:= True;
end;

procedure TdmCommon.tdcGetKeyFields(Sender: TObject; const FieldsM, FieldsT: TStrings);
begin
  FieldsM.Clear;
  FieldsM.Add('SPS_NODE');
  FieldsM.Add('ELEMENT');

  FieldsT.Clear;
  FieldsT.Add('PLC_ID');
  FieldsT.Add('Alarm_no');
end;

procedure TdmCommon.tdcGetSelectSQL(Sender: TObject; const SQLM, SQLT: TStrings);
begin
  SQLM.Clear;
  SQLM.Add('SELECT 12 AS SPS_NODE, ELEMENT, KOMMT, GEHT FROM ALARME WHERE SPS_NODE=1');
  SQLT.Clear;
  SQLT.Add('SELECT PLC_ID, Alarm_no, Alarm_On, Alarm_Off FROM Alarme');
end;

end.
